/*
Firmware for an auto-baudrate-detector and -convertor implemented in an
ATTiny2313.
(C) 2009 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
	    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
			    
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "uart.h"
#include "timer.h"
#include <stdio.h>
#include <avr/interrupt.h>
#include <avr/io.h>

//Support for the main, hardware, uart which
//talks to the PC at a fixed rate

//Send a long integer (up to 999999) as decimal to the serial port
void serialPutInt(unsigned long i) {
	char n;
	unsigned long r=100000;
	char first=1;
	while(r) {
		n='0';
		while (i>=r) {
			n++;
			i-=r;
		}
		if (!first || n!='0') serialPutChar(n);
		if (n!='0') first=0;
		r=r/10;
	}
}

//Send a char to the serial port
void serialPutChar(char c) {
	while((UCSRA&(1<<UDRE))==0) ;
	UDR=c;
}

//Hw uart rx int vect. Just push the byte to the sw uart on the devices side.
ISR(USART_RX_vect) { 
	unsigned char c=UDR;
	sei();
    swUartSend(c);
}


